/*
 * Copyright (C) 2017 Clivern. <https://clivern.com>
 */
package com.clivern.racter.receivers.webhook;

import java.util.HashMap;
import java.util.Map;
import org.json.JSONObject;
import org.json.JSONArray;

/**
 * Postback Webhook
 */
public class PostbackWebhook {
/*
{
  "sender":{
    "id":"USER_ID"
  },
  "recipient":{
    "id":"PAGE_ID"
  },
  "timestamp":1458692752478,
  "postback":{
    "payload": USER_DEFINED_PAYLOAD,
    "referral": {
      "ref": USER_DEFINED_REFERRAL_PARAM,
      "source": "SHORTLINK",
      "type": "OPEN_THREAD",
    }
  }
}  */
    private static PostbackWebhook instance;

    /**
     * Constructor
     */
    protected PostbackWebhook() { }

    /**
     * Get Instance
     *
     * @return PostbackWebhook
     */
    public static PostbackWebhook getInstance() {
        if(instance == null) {
            instance = new PostbackWebhook();
        }
        return instance;
    }
}